library R_Text;

  //////////////////////////////////////////////////////////////
  //  (C) PA.   MuzCat.    //
  //  www.zldo.narod.ru -                        //
  //  zldo@mail15.com -                                //
  //////////////////////////////////////////////////////////////

uses
  KOL,  // http://bonanzas.rinet.ru
  Windows,
  ShellApi,
  FreeRaportHeader;

type
  TPluginWorkMode = (SR_SimpleList, SR_Grupped, SR_CSV, SR_SCW);
  //   

const
  SCW_StdHeader = '=Small CD-Writer project='#13#10+
                  '[%s]'#13#10+
                  'ISO9660 = False'#13#10+
                  'Finalize = False'#13#10+
                  'BootCD = False'#13#10+
                  'BootImage ='#13#10;
  //   SCW 


var
  PlugType:PChar = ' '; //   
  FileName:string = 'C:\text-raport.txt';
  OwnerWND:THandle; //      
  f:integer;

  Additional1Name:string = '  1';
  Additional2Name:string = '  2';
  Additional3Name:string = '  3';
  Additional4Name:string = '  4';

  WorkMode:TPluginWorkMode;


function LevelTypeToStr(Const LevelType:integer):string;
//      
begin
  case LevelType of
    RAP_TO_Title:       result:='';
    RAP_TO_Artist:      result:='';
    RAP_TO_Album:       result:='';
    RAP_TO_Genre:       result:='';
    RAP_TO_Date:        result:='';
    RAP_TO_TrackNo:     result:=' ';
    RAP_TO_FileType:    result:=' ';
    RAP_TO_BitRate:     result:=' ';
    RAP_TO_FileSize:    result:=' ';
    RAP_TO_Time:        result:='';
    RAP_TO_Comment:     result:='';
    RAP_TO_FilePath:    result:='  ';
    RAP_TO_Folder:      result:='';
    RAP_TO_Drive:       result:='';
    RAP_TO_PlayCount:   result:='';
    RAP_TO_Additional1: result:=Additional1Name;
    RAP_TO_Additional2: result:=Additional2Name;
    RAP_TO_Additional3: result:=Additional3Name;
    RAP_TO_Additional4: result:=Additional4Name;
    RAP_TO_Rate:        result:='';
    else result:='';
  end;
end;

function GetOtstup(Const level:integer):string;
var
  x:integer;
begin
  result:='';
  for x:=1 to level do result:=result+'    ';
end;

function OpenRapFile:integer;
//     -   , \ 
var
  Dialog:TOpenSaveDialog;  //   
begin
  Dialog.WndOwner:=OwnerWND;
  Dialog.Filter:=' |*.txt|  |*.txt|CSV ( Excel)|*.csv| Small CD-Writer|*.scw';
  //   
  Dialog.OpenDialog:=false;
  if Dialog.Execute then
  begin //    
    FileName:=Dialog.Filename;
    case Dialog.FilterIndex of   //    WorkMode ( )
      1:WorkMode:=SR_SimpleList; //        
      2:WorkMode:=SR_Grupped;
      3:WorkMode:=SR_CSV;
      4:WorkMode:=SR_SCW;
    end;
    case Dialog.FilterIndex of
      1..2:FileName:=ChangeFileExt(FileName,'.txt'); //      
      3:FileName:=ChangeFileExt(FileName,'.csv');    //  
      4:FileName:=ChangeFileExt(FileName,'.scw');
    end;
    f:=KOL.FileCreate(FileName,ofCreateAlways+ofOpenReadWrite); //  
    if f=0 then result:=EN_ERROR_INTERNALERROR //     MuzCat   EN_ERROR_INTERNALERROR
           else result:=EN_ERROR_NONE;
  end
  else Result:=EN_ERROR_USERABORTED; //      
end;

function EnumCallBackProc_Grupped(Const State,Level,LevelType:integer;Const Info:pDBRec):integer;stdcall;
//       
var
  buf:string;
begin
//  
  case State of
    MC_RAP_START:result:=EN_ERROR_NONE; //    (   )
    MC_RAP_CLOSE:begin //   
                   result:=EN_ERROR_NONE; //   
                   FileClose(f); //    
                   ShellExecute(0,pchar('open'),pchar(FileName),'','',SW_SHOWNORMAL); //      
                 end;
    MC_RAP_LEVEL:try //  
                   buf:=#13#10+GetOtstup(Level)+LevelTypeToStr(LevelType)+' <<'+Info.Title+'>>'#13#10;
                   FileWrite(f,buf[1],length(buf)); //       (Info.Title -   )
                   Result:=EN_ERROR_NONE; //   
                 except
                   Result:=EN_ERROR_INTERNALERROR; //     (MuzCat  )
                 end;
    MC_RAP_El:try //   (      )
                buf:=GetOtstup(Level)+Info.Artist+' - '+Info.Title+' ('+info.TimeStr+')'#13#10;
                KOL.FileWrite(f,buf[1],length(buf)); //    
                Result:=EN_ERROR_NONE; //   
              except
                Result:=EN_ERROR_INTERNALERROR; //   
              end;
    else result:=EN_ERROR_INTERNALERROR; //   - 
  end;
end;

function EnumCallBackProc_Simple(Const State,Level,LevelType:integer;Const Info:pDBRec):integer;stdcall;
//   
//         
var
  buf:string;
begin
  case State of
    MC_RAP_START:result:=EN_ERROR_NONE;
    MC_RAP_CLOSE:begin
                   result:=EN_ERROR_NONE;
                   FileClose(f);
                   ShellExecute(0,pchar('open'),pchar(FileName),'','',SW_SHOWNORMAL);
                 end;
    MC_RAP_LEVEL:try
                   buf:=#13#10+'-===| '+LevelTypeToStr(LevelType)+' <<'+Info.Title+'>>'+' |===-'#13#10;
                   FileWrite(f,buf[1],length(buf));
                   Result:=EN_ERROR_NONE;
                 except
                   Result:=EN_ERROR_INTERNALERROR;
                 end;
    MC_RAP_El:try
                buf:=Info.Artist+' - '+Info.Title+' ('+info.TimeStr+')'#13#10;
                KOL.FileWrite(f,buf[1],length(buf));
                Result:=EN_ERROR_NONE;
              except
                Result:=EN_ERROR_INTERNALERROR;
              end;
    else result:=EN_ERROR_INTERNALERROR;
  end;
end;

const
  Separator = ';';

function NormalizeStr(Const s:string):string;
//       CSV 
var
  x:integer;
begin
  try
    result:=s;
    if pos('"',Result)<>0 then
    begin
      result:='';
      for x:=0 to length(s) do
        if s[x]='"' then result:=result+'""'
                    else result:=result+s[x];
      result:='"'+result+'"';
      exit;
    end;
    if pos(';',Result)<>0 then
    begin
      result:='"'+result+'"';
      exit;
    end;
    if pos(#13#10,Result)<>0 then
    begin
      result:='"'+result+'"';
      exit;
    end;
  finally
    if result='' then result:=' '
                 else result:=' '+result;
  end;
end;

function GetTitleCSVLine(Const Info:pDBRec):string;
//     CSV
begin
  result:=NormalizeStr(LevelTypeToStr(RAP_TO_Artist))+Separator+
          NormalizeStr(LevelTypeToStr(RAP_TO_Title))+Separator+
          NormalizeStr(LevelTypeToStr(RAP_TO_Album))+Separator+
          NormalizeStr(LevelTypeToStr(RAP_TO_Date))+Separator+
          NormalizeStr(LevelTypeToStr(RAP_TO_Genre))+Separator+
          NormalizeStr(LevelTypeToStr(RAP_TO_Time))+Separator+
          NormalizeStr(LevelTypeToStr(RAP_TO_FileSize))+Separator+
          NormalizeStr(LevelTypeToStr(RAP_TO_FileType))+Separator+
          NormalizeStr(LevelTypeToStr(RAP_TO_Drive))+Separator+
          NormalizeStr(LevelTypeToStr(RAP_TO_Folder))+Separator+
          NormalizeStr(LevelTypeToStr(RAP_TO_FilePath))+Separator+
          NormalizeStr(LevelTypeToStr(RAP_TO_Additional1))+Separator+
          NormalizeStr(LevelTypeToStr(RAP_TO_Additional2))+Separator+
          NormalizeStr(LevelTypeToStr(RAP_TO_Additional3))+Separator+
          NormalizeStr(LevelTypeToStr(RAP_TO_Additional4))+Separator+
          NormalizeStr(LevelTypeToStr(RAP_TO_Rate))+Separator+
          NormalizeStr(LevelTypeToStr(RAP_TO_TrackNo))+Separator+
          NormalizeStr(LevelTypeToStr(RAP_TO_BitRate))+Separator+
          NormalizeStr(LevelTypeToStr(RAP_TO_PlayCount))+Separator+#13#10;
end;

function GetCSVLine(Const Info:pDBRec):string;
//    CSV
begin
  result:=NormalizeStr(info.Artist)+Separator+
          NormalizeStr(info.Title)+Separator+
          NormalizeStr(info.Album)+Separator+
          NormalizeStr(info.Date)+Separator+
          NormalizeStr(info.Genre)+Separator+
          NormalizeStr(info.TimeStr)+Separator+
          NormalizeStr(info.FileSizeStr)+Separator+
          NormalizeStr(info.FileType)+Separator+
          NormalizeStr(info.Drive)+Separator+
          NormalizeStr(info.Folder)+Separator+
          NormalizeStr(info.FilePath)+Separator+
          NormalizeStr(info.Additional1)+Separator+
          NormalizeStr(info.Additional2)+Separator+
          NormalizeStr(info.Additional3)+Separator+
          NormalizeStr(info.Additional4)+Separator+
          NormalizeStr(Int2Str(info.Rate))+Separator+
          NormalizeStr(Int2Str(info.TrackNo))+Separator+
          NormalizeStr(Int2Str(info.BitRate))+Separator+
          NormalizeStr(Int2Str(info.PlayCount))+Separator+#13#10;
end;

function EnumCallBackProc_CSV(Const State,Level,LevelType:integer;Const Info:pDBRec):integer;stdcall;
//  CSV 
//    ,     
var
  buf:string;
begin
  case State of
    MC_RAP_START:try  //   
                   buf:=GetTitleCSVLine(Info);
                   KOL.FileWrite(f,buf[1],length(buf)); //   CSV   
                   Result:=EN_ERROR_NONE;
                 except
                   Result:=EN_ERROR_INTERNALERROR;
                 end;
    MC_RAP_CLOSE:begin
                   result:=EN_ERROR_NONE;
                   FileClose(f);
                   ShellExecute(0,pchar('open'),pchar(FileName),'','',SW_SHOWNORMAL);
                 end;
    MC_RAP_LEVEL:result:=EN_ERROR_NONE; //    .
    MC_RAP_El:try
                buf:=GetCSVLine(Info);
                KOL.FileWrite(f,buf[1],length(buf));
                Result:=EN_ERROR_NONE;
              except
                Result:=EN_ERROR_INTERNALERROR;
              end;
    else result:=EN_ERROR_INTERNALERROR;
  end;
end;

function GetSCWSeparator(Const Level:integer):string;
var
  x:integer;
begin
  result:='';
  for x:=0 to Level-2 do result:=result+Chr(VK_TAB);
end;

function EnumCallBackProc_SCW(Const State,Level,LevelType:integer;Const Info:pDBRec):integer;stdcall;
var
  buf:string;
begin
  case State of
    MC_RAP_START:try  //   
                   buf:=Format(SCW_StdHeader,[DateTime2StrShort(Now)]);
                   //buf:=SCW_StdHeader;
                   KOL.FileWrite(f,buf[1],length(buf)); //   SCW  
                   Result:=EN_ERROR_NONE;
                 except
                   Result:=EN_ERROR_INTERNALERROR;
                 end;
    MC_RAP_CLOSE:begin
                   result:=EN_ERROR_NONE;
                   FileClose(f);
                   ShellExecute(0,pchar('open'),pchar(FileName),'','',SW_SHOWNORMAL);
                 end;
    MC_RAP_LEVEL:try
                   buf:=#13#10'0'+GetSCWSeparator(Level)+Info.Title;
                   KOL.FileWrite(f,buf[1],length(buf));
                   Result:=EN_ERROR_NONE;
                 except
                   Result:=EN_ERROR_INTERNALERROR;
                 end;
    MC_RAP_El:try
                buf:=#13#10'1'+GetSCWSeparator(Level)+Info.FilePath;
                KOL.FileWrite(f,buf[1],length(buf));
                Result:=EN_ERROR_NONE;
              except
                Result:=EN_ERROR_INTERNALERROR;
              end;
    else result:=EN_ERROR_INTERNALERROR;
  end;
end;

function EnumCallBackProc(Const State,Level,LevelType:integer;Const Info:pDBRec):integer;stdcall;
//    
begin
  Result:=EN_ERROR_NONE;
  if State =  MC_RAP_START then Result:=OpenRapFile; //  -        
  if Result<>EN_ERROR_NONE then exit; //    
  case WorkMode of //          
    SR_Grupped:result:=EnumCallBackProc_Grupped(State,Level,LevelType,Info);
    SR_SimpleList:result:=EnumCallBackProc_Simple(State,Level,LevelType,Info);
    SR_CSV:result:=EnumCallBackProc_CSV(State,Level,LevelType,Info);
    SR_SCW:result:=EnumCallBackProc_SCW(State,Level,LevelType,Info);
    else result:=EN_ERROR_INTERNALERROR;
  end;
end;

procedure RapInitProc(Var PluginType:PChar;Const Owner:THandle);stdcall;
//  
begin
  PluginType:=PlugType; //   
  OwnerWND:=Owner; //    
end;

function EnumNeedRepeat:boolean;stdcall;
//     
begin
  result:=false; //  
end;

procedure Configure(Const Owner:THandle);stdcall;
//  .     ,       
begin
 MessageBox(Owner,PChar('       '#13#10+
                        '   MuzCat     .'#13#10#13#10+
                        '      .'#13#10+
                        '     " "  '#13#10+
                        '.'#13#10#13#10+
                        '() PA 2004'),'TextReport',MB_OK + MB_ICONINFORMATION);
end;

procedure SetAdditionalNames(Const A1,A2,A3,A4:PChar);stdcall;
//     (MuzCat       )
begin
 Additional1Name:=A1;
 Additional2Name:=A2;
 Additional3Name:=A3;
 Additional4Name:=A4;
end;


//        
exports
  EnumCallBackProc,
  RapInitProc,
  EnumNeedRepeat,
  Configure,
  SetAdditionalNames;

begin
end.
